/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010 Facebook, Inc. (http://www.facebook.com)          |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#include <cpp/base/array/array_element.h>
#include <cpp/base/array/array_init.h>

namespace HPHP {

IMPLEMENT_SMART_ALLOCATION_NOCALLBACKS(ArrayElement);
///////////////////////////////////////////////////////////////////////////////

void ArrayElement::dump() {
  m_name.dump();
  m_value.dump();
  printf("hash: %lld\n", m_hash);
}

Variant ArrayElement::getName() const {
  ASSERT(hasName());
  return ArrayInit::getName(m_name);
}

///////////////////////////////////////////////////////////////////////////////
}
